"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _draftJs = require("draft-js");

const changeCurrentBlockType = function changeCurrentBlockType(editorState, type, text) {
  let blockMetadata = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
  const currentContent = editorState.getCurrentContent();
  let selection = editorState.getSelection();
  const key = selection.getStartKey();
  const blockMap = currentContent.getBlockMap();
  const block = blockMap.get(key);
  const data = block.getData().merge(blockMetadata);
  const newBlock = block.merge({
    type,
    data,
    text
  });
  const lastOffset = text.length;

  if (selection.getFocusOffset() > lastOffset) {
    selection = selection.merge({
      anchorOffset: lastOffset,
      focusOffset: lastOffset
    });
  }

  const newContentState = currentContent.merge({
    blockMap: blockMap.set(key, newBlock),
    selectionAfter: selection
  });
  return _draftJs.EditorState.push(editorState, newContentState, "change-block-type");
};

var _default = changeCurrentBlockType;
exports.default = _default;