"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _draftJs = require("draft-js");

var _changeCurrentInlineStyle = _interopRequireDefault(require("./changeCurrentInlineStyle"));

var _constants = require("../constants");

var _insertText = _interopRequireDefault(require("./insertText"));

var _utils = require("../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const handleChange = (editorState, line, whitelist) => {
  let newEditorState = editorState;
  Object.keys(_constants.inlineMatchers).filter(matcher => whitelist.includes(matcher)).some(k => {
    _constants.inlineMatchers[k].some(re => {
      let matchArr;

      do {
        matchArr = re.exec(line);

        if (matchArr) {
          if (matchArr[0][0].match(/^\s/)) {
            matchArr[0] = matchArr[0].replace(/^\s/, "");
            matchArr.index += 1;
          }

          newEditorState = (0, _changeCurrentInlineStyle.default)(newEditorState, matchArr, k);
        }
      } while (matchArr);

      return newEditorState !== editorState;
    });

    return newEditorState !== editorState;
  });
  return newEditorState;
};

const handleInlineStyle = (whitelist, editorStateWithoutCharacter, character) => {
  const editorState = (0, _insertText.default)(editorStateWithoutCharacter, character);
  let selection = editorState.getSelection();
  let line = (0, _utils.getCurrentLine)(editorState);
  let newEditorState = handleChange(editorState, line, whitelist);
  let lastEditorState = editorState; // Recursively resolve markdown, e.g. _*text*_ should turn into both italic and bold

  while (newEditorState !== lastEditorState) {
    lastEditorState = newEditorState;
    line = (0, _utils.getCurrentLine)(newEditorState);
    newEditorState = handleChange(newEditorState, line, whitelist);
  }

  if (newEditorState !== editorState) {
    let newContentState = newEditorState.getCurrentContent();
    selection = newEditorState.getSelection();

    if (character === "\n") {
      newContentState = _draftJs.Modifier.splitBlock(newContentState, selection);
    }

    newEditorState = _draftJs.EditorState.push(newEditorState, newContentState, "md-to-inline-style");
    return newEditorState;
  }

  return editorStateWithoutCharacter;
};

var _default = handleInlineStyle;
exports.default = _default;