"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _changeCurrentBlockType = _interopRequireDefault(require("./changeCurrentBlockType"));

var _insertEmptyBlock = _interopRequireDefault(require("./insertEmptyBlock"));

var _splitBlockAndChange = _interopRequireDefault(require("./splitBlockAndChange"));

var _constants = require("../constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const handleNewCodeBlock = editorState => {
  const contentState = editorState.getCurrentContent();
  const selection = editorState.getSelection();
  const key = selection.getStartKey();
  const currentBlock = contentState.getBlockForKey(key);

  const matchData = _constants.CODE_BLOCK_REGEX.exec(currentBlock.getText());

  const currentText = currentBlock.getText();
  const endOffset = selection.getEndOffset(); // We .trim the text here to make sure pressing enter after "``` " works even if the cursor is before the space

  const isLast = endOffset === currentText.length || endOffset === currentText.trim().length;

  if (matchData && isLast) {
    const data = {};
    const language = matchData[1];

    if (language) {
      data.language = language;
    }

    const editorStateWithCodeBlock = (0, _changeCurrentBlockType.default)(editorState, "code-block", "", data);
    return (0, _splitBlockAndChange.default)(editorStateWithCodeBlock, undefined, undefined, false);
  }

  const type = currentBlock.getType();

  if (type === "code-block" && isLast) {
    return (0, _insertEmptyBlock.default)(editorState, "code-block", currentBlock.getData());
  }

  return editorState;
};

var _default = handleNewCodeBlock;
exports.default = _default;