"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _draftJs = require("draft-js");

const splitBlockAndChange = function splitBlockAndChange(editorState) {
  let type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "unstyled";
  let blockMetadata = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  let selectNewBlock = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
  let currentContent = editorState.getCurrentContent();
  const currentSelection = editorState.getSelection();
  currentContent = _draftJs.Modifier.splitBlock(currentContent, currentSelection);
  const selection = currentContent.getSelectionAfter();
  const key = selection.getStartKey();
  const blockMap = currentContent.getBlockMap();
  const block = blockMap.get(key);
  const data = block.getData().merge(blockMetadata);
  const newBlock = block.merge({
    type,
    data
  });
  const newContentState = currentContent.merge({
    blockMap: blockMap.set(key, newBlock),
    selectionAfter: selectNewBlock ? selection : currentSelection
  });
  return _draftJs.EditorState.push(editorState, newContentState, "split-block");
};

var _default = splitBlockAndChange;
exports.default = _default;